/*
 * Go2ProfileFlush.c
 * 
 * Gocator system communication library
 * Copyright (C) 2013 by LMI Technologies Inc.
 * 
 * Licensed under The MIT License.
 * Redistributions of files must retain the above copyright notice.
 */

#include <z/Go2Measurements/zGo2ProfileFlush.h>
#include <z/zGo2ProfileTypes.h>
#include <z/zGo2System.h>
#include <string.h>

/*
 * Go2ProfileFlush Class 
 */


GO2_EXPORT(Go2Status) Go2ProfileFlush_Construct(Go2ProfileFlush* measurement, Go2UInt32 id, Go2Object system)
{
    Go2ProfileFlush output = zNIL; 
    Go2Status status = GO2_OK; 

    zCHECK(zCalloc(&output, 1, sizeof(Go2ProfileFlushClass))); 

    if (!zSUCCESS(status = Go2ProfileFlush_Init(output, id, system)))
    {
        zCHECK(Go2Object_Destroy(output)); 
        return status; 
    }
    
    *measurement = output; 

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileFlush_Init(Go2ProfileFlush measurement, Go2UInt32 id, Go2Object system)
{
    Go2ProfileFlushClass* obj = zHANDLE_POINTER(measurement);

    zCHECK(Go2Measurement_Init(measurement, GO2_TYPE_PROFILE_FLUSH, id, system)); 

    obj->Release = Go2ProfileFlush_VRelease; 
    obj->Read = Go2ProfileFlush_VRead; 
    obj->Write = Go2ProfileFlush_VWrite; 

    zCHECK(Go2ProfileEdge_Construct(&obj->leftEdge, system));   
    zCHECK(Go2ProfileEdge_Construct(&obj->rightEdge, system));   

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileFlush_VRelease(Go2ProfileFlush measurement)
{
    Go2ProfileFlushClass* obj = zHANDLE_POINTER(measurement);

    zCHECK(Go2Object_Destroy(obj->leftEdge)); 
    zCHECK(Go2Object_Destroy(obj->rightEdge)); 

    zCHECK(Go2Measurement_VRelease(measurement));  
        
    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileFlush_VRead(Go2ProfileFlush measurement, zXml xml, zXmlItem item)
{
    Go2ProfileFlushClass* obj = zHANDLE_POINTER(measurement); 
    zChar* text = zNULL;
    z32u textCapacity = GO2_MEASUREMENT_SOURCE_TEXT_CAPACITY; 
    zXmlItem edgeItem = zNIL; 

    zCHECK(Go2Measurement_VRead(measurement, xml, item)); 

    zCHECK(zCalloc(&text, textCapacity, sizeof(zChar)));
    zCHECK(zXml_ChildText(xml, item, "SourceOptions", text, textCapacity)); 
    zCHECK(Go2OptionList_ParseList(text, obj->sourceOptions));  

    zCHECK(zXml_Child32s(xml, item, "Source", (z32s*) &obj->source)); 
    zCHECK(zXml_Child32s(xml, item, "ReferenceSide", (z32s*) &obj->referenceSide)); 
    zCHECK(zXml_Child64f(xml, item, "GapWidthMax", &obj->gapWidthMax)); 

    edgeItem = zXml_Child(xml, item, "LeftSide");
    zCHECK(!zIS_NIL(edgeItem));
    zCHECK(Go2ProfileEdge_Read(obj->leftEdge, xml, edgeItem)); 

    edgeItem = zXml_Child(xml, item, "RightSide");
    zCHECK(!zIS_NIL(edgeItem));
    zCHECK(Go2ProfileEdge_Read(obj->rightEdge, xml, edgeItem)); 

    zCHECK(zFree(text));

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileFlush_VWrite(Go2ProfileFlush measurement, zXml xml, zXmlItem item)
{
    Go2ProfileFlushClass* obj = zHANDLE_POINTER(measurement); 
    zXmlItem edgeItem = zNIL; 

    zCHECK(Go2Measurement_VWrite(measurement, xml, item)); 

    zCHECK(zXml_SetChild32u(xml, item, "Source", obj->source)); 
    zCHECK(zXml_SetChild32s(xml, item, "ReferenceSide", obj->referenceSide)); 
    zCHECK(zXml_SetChild64f(xml, item, "GapWidthMax", obj->gapWidthMax)); 

    zCHECK(zXml_AddItem(xml, item, "LeftSide", &edgeItem)); 
    zCHECK(Go2ProfileEdge_Write(obj->leftEdge, xml, edgeItem)); 

    zCHECK(zXml_AddItem(xml, item, "RightSide", &edgeItem)); 
    zCHECK(Go2ProfileEdge_Write(obj->rightEdge, xml, edgeItem)); 
    
    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileFlush_SetId(Go2ProfileFlush measurement, Go2UInt32 id)
{
    return Go2Measurement_SetId(measurement, id);     
}

GO2_EXPORT(Go2UInt32) Go2ProfileFlush_Id(Go2ProfileFlush measurement)
{
    return Go2Measurement_Id(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileFlush_SetName(Go2ProfileFlush measurement, const Go2Char* name)
{
    return Go2Measurement_SetName(measurement, name);     
}

GO2_EXPORT(Go2Status) Go2ProfileFlush_Name(Go2ProfileFlush measurement, Go2Char* name, Go2UInt32 capacity)
{
    return Go2Measurement_Name(measurement, name, capacity);     
}

GO2_EXPORT(Go2UInt32) Go2ProfileFlush_SourceOptionCount(Go2ProfileFlush measurement)
{
    return Go2Measurement_SourceOptionCount(measurement);     
}

GO2_EXPORT(Go2ProfileSource) Go2ProfileFlush_SourceOptionAt(Go2ProfileFlush measurement, Go2UInt32 index)
{
    return Go2Measurement_SourceOptionAt(measurement, index);     
}

GO2_EXPORT(Go2Status) Go2ProfileFlush_SetSource(Go2ProfileFlush measurement, Go2ProfileSource source)
{
    return Go2Measurement_SetSource(measurement, source);     
}

GO2_EXPORT(Go2ProfileSource) Go2ProfileFlush_Source(Go2ProfileFlush measurement)
{
    return Go2Measurement_Source(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileFlush_SetDecisionMin(Go2ProfileFlush measurement, Go2Double min)
{
    return Go2Measurement_SetDecisionMin(measurement, min);     
}

GO2_EXPORT(Go2Double) Go2ProfileFlush_DecisionMin(Go2ProfileFlush measurement)
{
    return Go2Measurement_DecisionMin(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileFlush_SetDecisionMax(Go2ProfileFlush measurement, Go2Double max)
{
    return Go2Measurement_SetDecisionMax(measurement, max);     
}

GO2_EXPORT(Go2Double) Go2ProfileFlush_DecisionMax(Go2ProfileFlush measurement)
{
    return Go2Measurement_DecisionMax(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileFlush_EnableHold(Go2ProfileFlush measurement, Go2Bool enable)
{
    return Go2Measurement_EnableHold(measurement, enable);  
} 

GO2_EXPORT(Go2Bool) Go2ProfileFlush_HoldEnabled(Go2ProfileFlush measurement)
{
    return Go2Measurement_HoldEnabled(measurement);  
}

GO2_EXPORT(Go2Status) Go2ProfileFlush_EnableSmoothing(Go2ProfileFlush measurement, Go2Bool enable)
{
    return Go2Measurement_EnableSmoothing(measurement, enable);  
} 

GO2_EXPORT(Go2Bool) Go2ProfileFlush_SmoothingEnabled(Go2ProfileFlush measurement)
{
    return Go2Measurement_SmoothingEnabled(measurement);  
} 

GO2_EXPORT(Go2UInt32) Go2ProfileFlush_SmoothingWindowMin(Go2ProfileFlush measurement)
{
    return Go2Measurement_SmoothingWindowMin(measurement);  
} 

GO2_EXPORT(Go2UInt32) Go2ProfileFlush_SmoothingWindowMax(Go2ProfileFlush measurement)
{
    return Go2Measurement_SmoothingWindowMax(measurement);  
} 

GO2_EXPORT(Go2Status) Go2ProfileFlush_SetSmoothingWindow(Go2ProfileFlush measurement, Go2UInt32 window)
{
    return Go2Measurement_SetSmoothingWindow(measurement, window);  
} 

GO2_EXPORT(Go2UInt32) Go2ProfileFlush_SmoothingWindow(Go2ProfileFlush measurement)
{
    return Go2Measurement_SmoothingWindow(measurement);  
} 

GO2_EXPORT(Go2ProfileEdge) Go2ProfileFlush_LeftEdge(Go2ProfileFlush measurement)
{
    Go2ProfileFlushClass* obj = zHANDLE_POINTER(measurement); 
    return obj->leftEdge;
}

GO2_EXPORT(Go2ProfileEdge) Go2ProfileFlush_RightEdge(Go2ProfileFlush measurement)
{
    Go2ProfileFlushClass* obj = zHANDLE_POINTER(measurement); 
    return obj->rightEdge;
}

GO2_EXPORT(Go2Status) Go2ProfileFlush_SetReferenceSide(Go2ProfileFlush measurement, Go2Side side)
{
    Go2ProfileFlushClass* obj = zHANDLE_POINTER(measurement); 

    zCHECK(Go2System_CheckConfigurable(obj->system)); 
    obj->referenceSide = side; 
    zCHECK(Go2System_SetModified(obj->system)); 

    return GO2_OK; 
}
 
GO2_EXPORT(Go2Side) Go2ProfileFlush_ReferenceSide(Go2ProfileFlush measurement)
{
    Go2ProfileFlushClass* obj = zHANDLE_POINTER(measurement); 
    return obj->referenceSide;   
}

GO2_EXPORT(Go2Status) Go2ProfileFlush_SetGapWidthMax(Go2ProfileFlush measurement, Go2Double gapWidthMax)
{
    Go2ProfileFlushClass* obj = zHANDLE_POINTER(measurement); 

    zCHECK(Go2System_CheckConfigurable(obj->system)); 
    obj->gapWidthMax = gapWidthMax; 
    zCHECK(Go2System_SetModified(obj->system)); 

    return GO2_OK; 
}
 
GO2_EXPORT(Go2Double) Go2ProfileFlush_GapWidthMax(Go2ProfileFlush measurement)
{
    Go2ProfileFlushClass* obj = zHANDLE_POINTER(measurement); 
    return obj->gapWidthMax;   
}



GO2_EXPORT(Go2Status) Go2ProfileFlush_SetScale(Go2ProfileFlush measurement, Go2Double scale){
    return Go2Measurement_SetScale(measurement, scale);
}

GO2_EXPORT(Go2Double) Go2ProfileFlush_Scale(Go2ProfileFlush measurement){
    return Go2Measurement_Scale(measurement);
}

GO2_EXPORT(Go2Status) Go2ProfileFlush_SetOffset(Go2ProfileFlush measurement, Go2Double offset){
    return Go2Measurement_SetOffset(measurement, offset);
}

GO2_EXPORT(Go2Double) Go2ProfileFlush_Offset(Go2ProfileFlush measurement){
    return Go2Measurement_Offset(measurement);
}

GO2_EXPORT(Go2UInt32) Go2ProfileFlush_LinkOptionCount(Go2ProfileFlush measurement)
{
    return Go2Measurement_LinkOptionCount(measurement);
}

GO2_EXPORT(Go2UInt32) Go2ProfileFlush_LinkOptionAt(Go2ProfileFlush measurement, Go2UInt32 index)
{
    return Go2Measurement_LinkOptionAt(measurement, index);
}

GO2_EXPORT(Go2Status) Go2ProfileFlush_EnableLink(Go2ProfileFlush measurement, Go2Bool enable)  
{
    return Go2Measurement_EnableLink(measurement, enable);  
}

GO2_EXPORT(Go2Bool) Go2ProfileFlush_LinkEnabled(Go2ProfileFlush measurement)  
{
    return Go2Measurement_LinkEnabled(measurement);  
}

GO2_EXPORT(Go2Status) Go2ProfileFlush_SetLink(Go2ProfileFlush measurement, Go2UInt32 link) 
{
    return Go2Measurement_SetLink(measurement, link); 
}

GO2_EXPORT(Go2UInt32) Go2ProfileFlush_Link(Go2ProfileFlush measurement) 
{
    return Go2Measurement_Link(measurement); 
}
